package gui;

import java.awt.Color;
import java.awt.Point;
import java.util.List;

import logic.Pin;

// Klasa koja predstavja jednu liniju
// ( linija inace ima jedan ulazni i vise izlaznih pinova, pa zato postoje niz nizova tacaka )
//
public class GuiPinLine extends GuiLine {

	protected Pin pin;

	public GuiPinLine(List<List<Point>> sections, Pin pin) {
		this(sections, pin, convertToSize(pin));
	}

	public GuiPinLine(List<List<Point>> sections, Pin pin, float size) {
		super(sections, Color.BLACK, size);
		this.pin = pin;
	}

	public void update() {
		if (pin.isHighZ()) {
			color = Color.GREEN;
		} else {
			if (pin.isBool()) {
				if (pin.getBoolVal())
					color = Color.RED;
				else
					color = Color.BLUE;
			} else {
				color = Color.GRAY;
			}
		}
	}

	private static float convertToSize(Pin pin) {
		if (pin == null)
			return 1;
		int numberOfLines = pin.getNumOfLines();
		if (numberOfLines <= 1)
			return 1;
		if (numberOfLines <= 4)
			return 1.5f;
		if (numberOfLines <= 8)
			return 2;
		if (numberOfLines <= 16)
			return 2.5f;
		return 3;
	}

	public Pin getPin() {
		return pin;
	}

	public void setPin(Pin pin) {
		this.pin = pin;
	}
}
