package gui.components;

import java.awt.Point;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import gui.Drawable;
import gui.GuiImageLabel;
import gui.GuiLine;
import gui.GuiPinLine;
import gui.GuiTextLabel;
import logic.LogicalComponent;

public class NotGui extends OneOutGui {

	public NotGui(LogicalComponent not, int x, int y, String[] args, boolean printInPortName, boolean printOutPortName) {
		super(not, x, y, args, printInPortName, printOutPortName, "src/images/NOT.png");
	}

	@Override
	public List<Drawable> getDrawables(){
		List<Drawable> gui = new LinkedList<Drawable>();
		
		GuiLine line;
		GuiTextLabel label;

		List<List<Point>> sections;
		List<Point> points;

		int numberOfInputPins = component.getInPins().length;
		if (numberOfInputPins != 1) {
			return gui;
		}

		sections = new ArrayList<List<Point>>();
		points = new ArrayList<Point>();
		points.add(new Point(x + 106 - 35, y + 20));
		points.add(new Point(x + 113 - 35, y + 20));
		sections.add(points);
		line = new GuiPinLine(sections, component.getInPin(0));
		drawables.add(line);
		if (printInPortName) {
			label = getLabel(component.getInPin(0), x + 100 - 33, y + 20);
			drawables.add(label);
		}

		sections = new ArrayList<List<Point>>();
		points = new ArrayList<Point>();
		points.add(new Point(x + 136 - 35, y + 20));
		points.add(new Point(x + 146 - 35, y + 20));
		sections.add(points);
		line = new GuiPinLine(sections, component.getOutPin(0));
		drawables.add(line);
		if (printOutPortName) {
			String outName = component.getOutPin(0).getName();
			if ((outName != null) && !("".equals(outName))) {
				label = new GuiTextLabel(x + 152 - 35, y + 20, outName, 12);
				drawables.add(label);
			}
		}

		GuiImageLabel im = new GuiImageLabel(x + 79, y + 10, imageURL);
		
		drawables.add(im);
		
		gui.addAll(drawables);

		return gui;
	}
}
