package logic.components;

import logic.*;

public class ADD extends LogicalComponent {

	public ADD() {
		this(2);
	}

	public ADD(int in) {
		super(in, 1);
	}

	public void setPinA(Pin pin) {
		setInPin(0, pin);
	}

	public void setPinB(Pin pin) {
		setInPin(1, pin);
	}

	public void func() {
		int A = 0;
		int B = 0;
		if (in[0].isBool()) {
			for (int i = 0; i < in.length / 2; i++) {
				if (this.in[i].isHighZ()) {
					out[0].setIntVal(0);
					return;
				}
				A = A << 1 | (in[i].getBoolVal() ? 1 : 0);
			}
			for (int i = in.length / 2; i < in.length; i++) {
				if (this.in[i].isHighZ()) {
					out[0].setIntVal(0);
					return;
				}
				B = B << 1 | (in[i].getBoolVal() ? 1 : 0);
			}
		} else {
			if (this.in[0].isHighZ() || this.in[1].isHighZ()) {
				if (out[0].getIntVal() != 0) {
					out[0].setIntVal(0);
				}
				return;
			}
			A = this.in[0].getIntVal();
			B = this.in[1].getIntVal();

		}

		int result = A + B;
		out[0].setIntVal(result);
		return;
	}

	@Override
	public void initArgs(String[] args) {
		this.args = args;
		this.name = args[1];
	}

}
