package logic.components;

import logic.LogicalComponent;

public class XOR extends LogicalComponent {

	public XOR() {
		this(2);
	}

	public XOR(int pinin) {
		super(pinin, 1);
	}

	public XOR(int in, String name) {
		super(in, 1);
		this.name = name;
	}

	public void func() {

		boolean result = in[0].getBoolVal() ^ in[1].getBoolVal();
		for (int i = 2; i < in.length; i++) {
			result ^= in[i].getBoolVal();
		}
		out[0].setBoolVal(result);
	}

	@Override
	public void initArgs(String[] args) {
		this.args = args;
		this.name = args[1];
		this.out[0].setName(args[args.length - 1]);
	}
}
